// #include <hmg.ch>
#include <minigui.ch>


Function Main
   local mrow := 10
   private bcr, bcg, bcb, fcr, fcg, fcy, lColorChanged
   
   bcr := bcg := bcb := 255
   fcr := fcg := fcb := 0
  lColorChanged := .F.
   

   readini()
   
   define window winmain at 0, 0 width 340 height 320 title "Color Change Test" main backcolor {bcr, bcg, bcb} on release AskSave()
   
      define label label1
         row mrow
         col 0
         value "Change Color:"
         fontbold .t.
         backcolor {bcr, bcg, bcb}
         fontcolor {fcr, fcg, fcb}
      end label
      
      mrow += 30
      define editbox edit1
         row mrow
         col 10
         width 300
         height 150
         fontcolor {fcr, fcg, fcb}
         backcolor {bcr, bcg, bcb}
         fontbold := .t.
         value "This is a color changing test!"
      end editbox

		mrow += 160

      DEFINE FRAME frame_1
		   COL 10
			ROW mRow
			CAPTION "Change colors"
			WIDTH 300
			HEIGHT 55
         FONTCOLOR {fcr, fcg, fcb}
         BACKCOLOR {bcr, bcg, bcb}
		END FRAME

		mRow += 20
		define button backcolor
         row mrow
         col 50
         caption "Back Color"
         action {|| getbackcolor()}
      end button
      
      define button forecolor
         row mrow
         col 180
         caption "Fore Color"
         action {|| getforecolor()}
      end button
      
      mrow += 40

      define button quit
         row mrow
         col 10
         caption "Quit"
         action {|| winmain.release()}
      end button

		/*
      define button save
         row mrow
         col 10
         caption "Save"
         action {|| saveini(), winmain.release()}
      end button
      
      define button cancel
         row mrow
         col 120
         caption "Cancel"
         action {|| winmain.release()}
      end button                      
		*/

   end window
   
   winmain.Center
   winmain.Activate

Return


//--------------------------------- AskSave()
Function AskSave()
memvar lColorChanged

If lColorChanged
	If	MsgYesNo("Colors has been changed!"+HB_OSNewLine()+ ;
	            "     Save them?         ", "Color Changes";
				  )
		saveini()
	Endif
Endif

//---------------------------- getbackcolor()
function getbackcolor()
   local acol := getcolor({bcr, bcg, bcb})
	if acol[1] <> bcr .or. acol[2] <> bcg .or. acol[3] <> bcb
      bcr := acol[1]
		bcg := acol[2]
	   bcb := acol[3]
      changecolor()
	endif

return nil

//---------------------------- getforecolor()
function getforecolor()
   local acol := getcolor({fcr, fcg, fcb})
   if acol[1] <> fcr .or. acol[2] <> fcg .or. acol[3] <> fcb
     	fcr := acol[1]
   	fcg := acol[2]
   	fcb := acol[3]
   	changecolor()
	endif
return nil
//---------------------------- changecolor()
function changecolor()
	memvar lColorChanged
	declare window winmain
	winmain.hide
		winmain.label1.backcolor := {bcr, bcg, bcb}
   	winmain.label1.fontcolor := {fcr, fcg, fcb}
   	winmain.edit1.backcolor := {bcr, bcg, bcb}
   	winmain.edit1.fontcolor := {fcr, fcg, fcb}
		winmain.frame_1.backcolor := {bcr, bcg, bcb}
      winmain.frame_1.fontcolor := {fcr, fcg, fcb}
		setproperty( 'winmain', 'backcolor',  {bcr, bcg, bcb} )
		// winmain.backcolor := {bcr, bcg, bcb}
	winmain.restore
	winmain.show

	lColorChanged := .T.
return nil

//------------------- SaveIni
function SaveIni()
   local mInifile := "main.ini"
	BEGIN INI FILE (mInifile)
		SET SECTION "BackColor"   ENTRY "Red"      To bcr
		SET SECTION "BackColor"   ENTRY "Green"    To bcg
		SET SECTION "BackColor"   ENTRY "Blue"     To bcb
		SET SECTION "ForeColor"   ENTRY "Red"      To fcr
		SET SECTION "ForeColor"   ENTRY "Green"    To fcg
		SET SECTION "ForeColor"   ENTRY "Blue"     To fcb
   END INI
return nil
   

//------------------- ReadIni
function ReadIni()
   local mInifile := "main.ini"

	If ! File(mInifile)
	  SaveIni()
	EndIf
	
	BEGIN INI FILE (mInifile)
	   GET bcr SECTION "BackColor" ENTRY "Red"
	   GET bcg SECTION "BackColor" ENTRY "Green"
	   GET bcb SECTION "BackColor" ENTRY "Blue"
	   GET fcr SECTION "ForeColor" ENTRY "Red"
	   GET fcg SECTION "ForeColor" ENTRY "Green"
	   GET fcb SECTION "ForeColor" ENTRY "Blue"
	END INI
	
return nil